#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using ld=double;
using vll=vector<ll>;
using vvll=vector<vector<ll>>;
#define FOR(i,a,b) for(ll i=a;i<(ll)b;++i)
#define F(n) FOR(i,0,n)
#define FF(n) FOR(j,0,n)
#define aa first
#define bb second
#define PB push_back
#define EQ(a,b) (fabs(a-b)<=(fabs(a+b)*EPS))
#define MOD ((ll)(1e9+7))
#define dbg cerr
#define out(n) cout << n << '\n'
#define INF (1ll << 40)

struct Dijkstra {
  struct Edge{
    ll v,w; // destination and weight
    bool operator<(const Edge& a)const{return w>a.w;}
  };

  ll n;
  const ll inf = (INF); // TODO: change this as needed
  vector<vector<Edge>> g;
  vll d,p;
  Dijkstra(ll n): n(n), g(vector<vector<Edge>>(n)), d(vll(n)), p(vll(n)) {}

  void add_edge(ll u,ll v,ll w){g[u].PB({v,w});}

  void run(ll s){
    F(n)d[i]=inf,p[i]=-1;
    d[s]=0;
    priority_queue<Edge> q;
    q.push({s,d[s]});
    while(q.size()){
      auto u=q.top().v;q.pop();
      for(auto e:g[u])
        if(d[e.v]>d[u]+e.w)
          d[e.v]=d[u]+e.w,p[e.v]=u,q.push({e.v,d[e.v]});
    }
  }
};

//#define dbg if(0)cerr
ll ilog2(ll n) {
  ll res = 0;
  while (n) {
    res ++;
    n/=2;
  }
  return res;
}

int main(){
  ios::sync_with_stdio(0);cin.tie(0);
  ll n, m;
  cin>>n>>m;
  vector<ll> w(n);
  vector<pair<pair<ll,ll>,ll>> in(m);
  F(n)cin>>w[i];
  F(m){
    cin >> in[i].aa.aa >> in[i].aa.bb >> in[i].bb;
  }

  ll its=ilog2(n);
  ll res=INF;
  for (ll it = 0; it < its; ++ it) {
    vll s, t;
    // build the graph
    Dijkstra dj(n+2);
    F(n){
      if ((i >> it)%2) dj.add_edge(n, i, w[i]);
      else dj.add_edge(i, n+1, w[i]);
    }
    F(m){
      dj.add_edge(in[i].aa.aa, in[i].aa.bb, in[i].bb);
      dj.add_edge(in[i].aa.bb, in[i].aa.aa, in[i].bb);
    }
    dj.run(n);
    res = min(res, dj.d[n+1]);
  }
  out(res);

  return 0;
}
